''
'' Object Loader/Viewer by ssjx (http://ssjx.co.uk)
''

#include "GL/gl.bi"
#include "GL/glu.bi"

'' object.bi has the object structures
#include "object.bi"

#define SC_UP &h48
#define SC_LEFT &h4B
#define SC_RIGHT &h4D
#define SC_DOWN &h50
#define SC_ESCAPE &h01
#define SC_Q &h10
#define SC_A &h1E

'' These are in object.bas
declare sub loadobject(as string, as myobject)
declare sub showobject(as myobject)


dim as myobject ship

''
'' Lighting (pasted from a nehe tutorial)
''

dim LightAmbient(0 to 3) as single => {0.5, 0.5, 0.5, 1}   '' Ambient Light Values ( NEW )
dim LightDiffuse(0 to 3) as single => {1.0, 1.0, 1.0, 1}   '' Diffuse Light Values ( NEW
dim LightPosition(0 to 3) as single => {0.0, 4.0, -2.0, 1.0}  '' Light Position ( NEW )

''
'' Main Program
''

dim as integer yrot=180,xrot=0,quit=0
dim as single dist=-6

''
'' Set up the screen
''

screen 18, 32, , 2
glViewport 0, 0, 640, 480
glMatrixMode GL_PROJECTION
glLoadIdentity
gluPerspective 45.0, 640.0/480.0, 0.1, 100.0
glMatrixMode GL_MODELVIEW
glLoadIdentity

glShadeModel GL_SMOOTH
glClearColor 0.0, 0.0, 0.0, 1.0
glClearDepth 1.0
glEnable GL_DEPTH_TEST
glDepthFunc GL_LEQUAL
glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST

glLightfv GL_LIGHT1, GL_AMBIENT, @LightAmbient(0)   
glLightfv GL_LIGHT1, GL_DIFFUSE, @LightDiffuse(0)   
glLightfv GL_LIGHT1, GL_POSITION, @LightPosition(0) 
glEnable GL_LIGHT1                                  

glEnable(GL_LIGHTING)  

glEnable(GL_COLOR_MATERIAL)
glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE)

glEnable GL_TEXTURE_2D

''
'' Load the object
''

loadobject("enterprise.obj",ship)

''
''
''
do
	''
	'' Controls...
	''				
	if  MultiKey(SC_LEFT) then
		yrot += 2
		if yrot=360 then yrot=0
	end if 

	if  MultiKey(SC_RIGHT) then
		if yrot=0 then yrot=360
		yrot -= 2
	end if

	if  MultiKey(SC_UP) then
		xrot += 2
		if xrot=360 then xrot=0
	end if 

	if  MultiKey(SC_DOWN) then
		xrot -= 2
		if xrot=0 then xrot=360
	end if
	
	if  MultiKey(SC_Q) then
		dist+=0.1
	end if
	
	
	if  MultiKey(SC_A) then
		dist-=0.1
	end if
	

	if MultiKey(SC_ESCAPE) then
		quit=1
	end if

	''
	'' Put everything in place and display
	''
	
	glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	glLoadIdentity
	glTranslatef 0, 0.0,dist '' -6.0
	glRotatef yrot, 0, 1,0 
	glRotatef xrot, 1, 0,0 
	
	showobject(ship)
	
	flip

sleep (1000/60)

loop while quit=0


end
