''
'' .obj load/show functions by ssjx (http://ssjx.co.uk)
''
''

#include "GL/gl.bi"
#include "GL/glu.bi"

'' 
''
#include "object.bi"

declare function load_texture(As String) as uinteger


''

sub loadobject(myfile as string, byref obj as myobject)
	dim as string txt,temp,tempb,ch,chb,matfile
	
	dim as integer pc=0,pno=1 ''vertex counters
	dim as integer qc=0,qno=0 ''quad counters
	dim as integer nc=0,nno=1 ''normal counters
	dim as integer tc=0,tno=1 ''texture counters
	dim as integer fc=0		''face counter
	dim as integer matcount=0
	dim as uinteger currentmat=0
	dim as colrgb currentdif
	
	dim mytexture(20) as texturelist ''also hold colour details (will prob rename later..)
	
	
	''
	'' Get material details (texture/colours) from .mtl file
	''

	matfile=left(myfile,len(myfile)-4)+".mtl"

	if  Open(matfile For input access read As #1)=0 then
	
		with obj
		Do Until EOF(1)
			line input #1,txt
			if left(txt,7)="newmtl " then
				matcount+=1
				print ""
				print "M: ["+mid(txt,8)+"]";	
				mytexture(matcount).matname=mid(txt,8)
			end if
			
			if left(txt,7)="map_Kd " then
				print "T"+str(matcount)+": ["+mid(txt,8)+"]"		
				mytexture(matcount).handle=load_texture(mid(txt,8))				
			end if
			
			if left(txt,3)="Kd " then
				print "Dif"+str(matcount)+": ["+mid(txt,4)+"]"		
				
				''
				txt+=" "
				tempb=""
				fc=0
				for j as integer=4 to len(txt)
					ch=mid(txt,j,1)
					if (ch=" ") then
						print "{"+tempb+"}";
						
						select case fc
						case 0:
							mytexture(matcount).dif.r=val(tempb)	
						case 1:
							mytexture(matcount).dif.g=val(tempb)	
						case 2:
							mytexture(matcount).dif.b=val(tempb)							
						end select
						
						fc+=1
						tempb=""
					else
						tempb+=ch
					end if
						
				next j
			end if
			
		loop
		end with
		Close #1  
	else
		print "Could not open the material file "+myfile
	end if
	
		
	''
	'' Load the actual object
	''
	
	print "Loading : "+myfile
	
	if  Open(myfile For input access read As #1)=0 then
	
	with obj
	Do Until EOF(1)
		line input #1,txt
	
		'' use material
		if left(txt,7)="usemtl " then
			currentmat=0
			for i as integer=1 to ubound(mytexture) 
					if mytexture(i).matname=mid(txt,8) then			
						currentmat=mytexture(i).handle
						currentdif=mytexture(i).dif
						print "Using: " + mytexture(i).matname
					else
					'	print "Texture not found"
					end if
			next i		
		end if
		
	
		'' Clear
		temp=""
		txt+=" " '' adding a space on the end makes extracting from the line easier...
			
		'' point/vertex
	
		if left(txt,2)="v " then
			print "V ";
			pc=0
		
			for i as integer=3 to len(txt)
			ch=mid(txt,i,1)
			
			if (ch=" ") then
				print "["+temp+"]";
				
				''add point
				if pc=0 then .pt(pno).x=val(temp)
				if pc=1 then .pt(pno).y=val(temp)
				if pc=2 then .pt(pno).z=val(temp)
				
				pc+=1
				''
				temp=""	
			else
				temp+=ch
			end if
			next i
			
			pno+=1
			
		end if 
		
		'' face
	
		if left(txt,2)="f " then
			qc=0
			print "F ";
		
			for i as integer=3 to len(txt)
			ch=mid(txt,i,1)
			
			if (ch=" " or asc(ch)=10 or asc(ch)=13) then
				print "["+temp+"]";
				temp+="/"
				fc=0
				''
				''extract vertex/texture/normal from above
				if instr(temp,"/")>0 then
					'' (we only want the last number)
					for j as integer=0 to len(temp)
					chb=mid(temp,j,1)
					if (chb="/") then
						print "{"+tempb+"}";
						
						select case fc
						case 0:
							.quad(qno).v(qc)=val(tempb)	
						case 1:
							.quad(qno).t(qc)=val(tempb)	
						case 2:
							.quad(qno).n(qc)=val(tempb)							
						end select
						
						fc+=1
						tempb=""
					else
						tempb+=chb
					end if
						
					next j
					
					.quad(qno).dif=currentdif
					
				else
					'' if only a vertex is specified
					
				
				end if
											
				qc+=1
				temp=""
			else
				temp+=ch
			end if
			
			next i
			 .quad(qno).type=qc				
			.quad(qno).tno=currentmat
			 
			qno+=1
			
		end if 
		
		'' normal
		
		if left(txt,3)="vn " then
			'print txt
			print "VN ";
			nc=0
			for i as integer=4 to len(txt)
			ch=mid(txt,i,1)
			
			if (ch=" ") then
				print "["+temp+"]";
				
				''add point
				if nc=0 then .normal(nno).x=val(temp)
				if nc=1 then .normal(nno).y=val(temp)
				if nc=2 then .normal(nno).z=val(temp)
				nc+=1
				''
				temp=""	
			else
				temp+=ch
			end if
			next i	
			nno+=1
			
		end if 
		'' end of normal parsing
		''
		
		
		''
		'' Get texture co-ordinates
		''
		
		if left(txt,3)="vt " then
			'print txt
			print "VT ";
			tc=0
			for i as integer=4 to len(txt)
			ch=mid(txt,i,1)
			
			if (ch=" " or asc(ch)=10 or asc(ch)=13) then
				print "["+temp+"]";
				
				''add point
				if tc=0 then .tpt(tno).x=val(temp)
				if tc=1 then .tpt(tno).y=val(temp)
				tc+=1
				''
				temp=""	
			else
				temp+=ch
			end if
			next i
			tno+=1
			
		end if 
		
		''
		''
		
		print ""
	loop
			''
		.faces=qno-1
		print "Faces: "+str(.faces)+" (+1 we count from zero..)"
		
	end with
	Close #1  
	else
		print "Could not open the object file "+myfile
	end if
	

	
	print "Done!"
end sub

''
''
''

sub showobject( byref obj as myobject)
	with obj
	
	for i as integer=0 to .faces
	
	glBindTexture GL_TEXTURE_2D, .quad(i).tno
	
	glColor3f .quad(i).dif.r,.quad(i).dif.g,.quad(i).dif.b
	
	select case as const .quad(i).type
	
	case 4:
		glBegin GL_QUADS
	
		for j as integer=0 to 3
		glNormal3f .normal(.quad(i).n(j)).x,.normal(.quad(i).n(j)).y,.normal(.quad(i).n(j)).z	
	
		glTexCoord2f(.tpt(.quad(i).t(j)).x,.tpt(.quad(i).t(j)).y)
	
		glVertex3f .pt(.quad(i).v(j)).x,.pt(.quad(i).v(j)).y,.pt(.quad(i).v(j)).z
		next j
		
		glEnd
	
	case 3:
			
		glBegin GL_TRIANGLES
	
		for j as integer=0 to 2
		glNormal3f .normal(.quad(i).n(j)).x,.normal(.quad(i).n(j)).y,.normal(.quad(i).n(j)).z	
	
		glTexCoord2f(.tpt(.quad(i).t(j)).x,.tpt(.quad(i).t(j)).y)
	
		glVertex3f .pt(.quad(i).v(j)).x,.pt(.quad(i).v(j)).y,.pt(.quad(i).v(j)).z
		next j
		glEnd
	
	case else:
	
		glBegin GL_POLYGON
	
		for j as integer=0 to .quad(i).type-1
		glNormal3f .normal(.quad(i).n(j)).x,.normal(.quad(i).n(j)).y,.normal(.quad(i).n(j)).z	
	
		glTexCoord2f(.tpt(.quad(i).t(j)).x,.tpt(.quad(i).t(j)).y)
	
		glVertex3f .pt(.quad(i).v(j)).x,.pt(.quad(i).v(j)).y,.pt(.quad(i).v(j)).z
		next j
		glEnd
	
	end select
	
	next i
	end with
end sub


''
'' Loads a 24bit bitmap texture and returns a handle
'' 

function load_texture(myfile As String) as uinteger
	dim as integer w=0,h=0,ps=0
	dim as uinteger handle=0
	dim as ubyte r,g,b
	dim header as textbmphdr
	Dim buffer As ubyte Ptr
	
	if  Open(myfile For binary access read As #2)=0 then
		get #2,,header
		
		w=header.w
		h=header.h
	
		buffer = Allocate(w*h*4)
		'	
		if buffer<>0 then 	
			for j as integer=0 to (h-1)
				ps=j*w*4	'' don't flip the image(that way it appears correct)
				
				for i as integer=(w-1) to 0 step -1
				
					get #2, ,b,1
					get #2, ,g,1
					get #2, ,r,1
					
					buffer[ps+(i*4) ]=b
					buffer[ps+(i*4)+1]=g
					buffer[ps+(i*4)+2]=r
					
					if r=255 and g=0 and b=255 then		
						buffer[ps+(i*4)+3]=&h00
					else
						buffer[ps+(i*4)+3]=&hff
					
					end if
					
				next i
			next j
		end if
	        Close #2 
	        
		'' make a texture from the image		
		glGenTextures 1, @handle
		glBindTexture GL_TEXTURE_2D, handle
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST) 
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST) 
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_BGRA, GL_UNSIGNED_BYTE, buffer)

		'' free buffer
		deallocate(buffer)

	else
		print "Cannot load texture file ["+myfile+"] "
			
	end if				
    
    return handle
End function
